package com.keyborad.theme.trendyborad.trendyuiactivity

import android.annotation.SuppressLint
import android.content.Intent
import android.graphics.drawable.Drawable
import android.os.Bundle
import android.util.Log
import android.view.View
import android.widget.FrameLayout
import android.widget.ImageView
import android.widget.LinearLayout
import android.widget.TextView
import android.widget.Toast
import androidx.activity.enableEdgeToEdge
import androidx.appcompat.app.AppCompatActivity
import androidx.core.view.OnApplyWindowInsetsListener
import androidx.core.view.ViewCompat
import androidx.core.view.WindowInsetsCompat
import androidx.core.view.isVisible
import androidx.lifecycle.lifecycleScope
import androidx.recyclerview.widget.GridLayoutManager
import androidx.recyclerview.widget.RecyclerView
import com.ad.tradpluslibrary.TPAdManager
import com.bumptech.glide.Glide
import com.bumptech.glide.integration.webp.decoder.WebpDrawable
import com.bumptech.glide.load.DataSource
import com.bumptech.glide.load.engine.GlideException
import com.bumptech.glide.request.RequestListener
import com.bumptech.glide.request.target.Target
import com.keyborad.theme.trendyborad.R
import com.keyborad.theme.trendyborad.TrendyApp
import com.keyborad.theme.trendyborad.bean.BeanDetails
import com.keyborad.theme.trendyborad.database.DatabaseManager
import com.keyborad.theme.trendyborad.trendycallback.TrendyOnItemClickCallback
import com.keyborad.theme.trendyborad.trendycallback.TrendySetKeyboardCallback
import com.keyborad.theme.trendyborad.trendylistutils.TrendySetKeyboardMoreAdapter
import com.keyborad.theme.trendyborad.trendyuifragment.TrendyDialogEnableKeyboard
import com.keyborad.theme.trendyborad.trendyutils.TrendyCommon
import com.keyborad.theme.trendyborad.trendyutils.TrendyDealZipFile
import com.keyborad.theme.trendyborad.trendyutils.TrendySaveCurrentTheme
import kotlinx.coroutines.launch
import java.io.File


class TrendySetKeyboardActivity : AppCompatActivity() {
    companion object {
        @JvmField
        var DISPLAY_URL_KEY: String = "display_url_key"

        @JvmField
        val ZIP_URL_KEY = "zip_url_key"


        @JvmField
        val NAME_KEY = "name_key"

        @JvmField
        val GIF_KEY = "gif_key"

        @JvmField
        val THUMB_KEY = "thumb_key"

        @JvmField
        val SOURCE_KEY = "data_key"
    }

    private var dialog: TrendyDialogEnableKeyboard? = null
    private lateinit var displayUrl: String
    private lateinit var gifUrl: String
    private lateinit var zipUrl: String
    private lateinit var name: String
    private lateinit var applyBtn: LinearLayout
    private lateinit var imgData: ImageView
    private lateinit var imgBack: ImageView
    private lateinit var textName: TextView

    private lateinit var recommendedRecycler: RecyclerView
//    private lateinit var viewAllLayout: LinearLayout

    private lateinit var loadingLayout: FrameLayout

    private lateinit var unzipPath: String

    private lateinit var tvDownload: TextView
    private lateinit var imDownload: ImageView

    private lateinit var thumb: String

    private lateinit var imgLike: ImageView

    private lateinit var data: BeanDetails

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        setContentView(R.layout.activity_st_kb_trendy)
        TPAdManager.loadAllAd(this)
        this.enableEdgeToEdge()
        ViewCompat.setOnApplyWindowInsetsListener(
            findViewById<View?>(R.id.main),
            OnApplyWindowInsetsListener { v: View?, insets: WindowInsetsCompat? ->
                val systemBars = insets!!.getInsets(WindowInsetsCompat.Type.systemBars())
                v!!.setPadding(systemBars.left, systemBars.top, systemBars.right, systemBars.bottom)
                insets
            })

        findViewId()
        getExtraData()
        displayData()
        setApply()
        onClick()
        TPAdManager.showTPAD(this@TrendySetKeyboardActivity) {  }
    }


    private fun getExtraData() {
        data = intent.getSerializableExtra(SOURCE_KEY) as BeanDetails

        displayUrl = intent.getStringExtra(DISPLAY_URL_KEY).toString()
        zipUrl = intent.getStringExtra(ZIP_URL_KEY).toString()
        name = intent.getStringExtra(NAME_KEY).toString()
        gifUrl = intent.getStringExtra(GIF_KEY).toString()
        thumb = intent.getStringExtra(THUMB_KEY).toString()

        val serviceZipName = TrendyDealZipFile.getServiceZipName(zipUrl)
        unzipPath = TrendyDealZipFile.getUnzipPath(serviceZipName)

        Log.d("-------------------", "-------unzipPath=" + unzipPath)
        lifecycleScope.launch {
            DatabaseManager.getIsLike(name) {
                imgLike.isSelected = it
            }
        }

        if (File(unzipPath).exists()) {
            imDownload.isVisible = false
            tvDownload.text = getString(R.string.apply)
        } else {
            imDownload.isVisible = true
            tvDownload.text = getString(R.string.download_apply)
        }

    }

    private fun findViewId() {
        applyBtn = findViewById(R.id.layoutDownloadApply)
        imgData = findViewById(R.id.image_data)
        imgBack = findViewById(R.id.back)
        textName = findViewById(R.id.textview_data_name)
        recommendedRecycler = findViewById(R.id.recommended_recycler)
//        viewAllLayout = findViewById(R.id.layout_view_all)

        imgLike = findViewById(R.id.im_like)
        loadingLayout = findViewById(R.id.loading)
        imDownload = findViewById(R.id.im_download)
        tvDownload = findViewById(R.id.tv_download)
    }

    private fun displayData() {
        textName.text = name
        if (gifUrl.isNotEmpty()) {
            loadImgGif()
        } else {
            Glide.with(this)
                .load(displayUrl)
                .thumbnail(Glide.with(this).load(thumb))
                .into(imgData)
        }
    }


    private fun onClick() {
        imgBack.setOnClickListener {
            TPAdManager.showTPAD(this@TrendySetKeyboardActivity){
                finish()
            }

        }

        imgLike.setOnClickListener {
            imgLike.isSelected = !imgLike.isSelected

            lifecycleScope.launch {
                if (imgLike.isSelected) {
                    DatabaseManager.addLike(data)
                } else {
                    DatabaseManager.removeLike(data)
                }
            }
        }
        val forYouList = TrendyApp.Companion.list.filter {
            it.parentName == getString(R.string.recommend_name)

        }

        recommendedRecycler.run {
            adapter =  TrendySetKeyboardMoreAdapter(
                this@TrendySetKeyboardActivity
            ).apply {
                val shuffled = forYouList[0].keyboardList.shuffled()
                setForYouList(shuffled)
            }.apply {
                setClickAction(object : TrendyOnItemClickCallback {
                    override fun OnItemClickListener() {
                        finish()
                    }

                })
            }

            layoutManager = GridLayoutManager(this@TrendySetKeyboardActivity, 2)

        }

    }

    @SuppressLint("CheckResult")
    private fun loadImgGif() {
        Glide.with(this)
            .load(gifUrl)
            .thumbnail(Glide.with(this).load(thumb))
            .addListener(object : RequestListener<Drawable> {
                override fun onLoadFailed(
                    e: GlideException?,
                    model: Any?,
                    target: Target<Drawable>,
                    isFirstResource: Boolean
                ): Boolean {

                    return false
                }

                override fun onResourceReady(
                    resource: Drawable,
                    model: Any,
                    target: Target<Drawable>?,
                    dataSource: DataSource,
                    isFirstResource: Boolean
                ): Boolean {
                    if (resource is WebpDrawable) {
                        resource.loopCount = WebpDrawable.LOOP_FOREVER
                    }

                    return false
                }

            }).into(imgData)
    }

    private fun setApply() {
        applyBtn.setOnClickListener {
            TPAdManager.showTPAD(this@TrendySetKeyboardActivity) {
                val checkEnable = TrendyCommon.checkEnable(this)
                val checkSetDefault = TrendyCommon.checkSetDefault(this)
                if (!checkEnable || !checkSetDefault) {
                    showDialog()
                    return@showTPAD
                }
                startDown()
            }


        }
    }

    private fun showDialog() {
        dialog = dialog ?: TrendyDialogEnableKeyboard.newInstance() .apply{


        }
        dialog?.setClickListener {
            startDown()
        }
        dialog?.show(supportFragmentManager, "")
    }

    private fun startDown() {
        loadingLayout.isVisible = true
        applyBtn.isEnabled = false

        val file = File(unzipPath)
        if (file.exists()) {
            val findFirstDirectory = TrendyDealZipFile.findFirstDirectory(file)

            apply("${findFirstDirectory}/")
            applyBtn.isEnabled = true
            loadingLayout.isVisible = false
        } else {
            TrendyDealZipFile.startDownloadZip(zipUrl, object :
                TrendySetKeyboardCallback {
                override fun OnApplySkinListener(fileList: List<File?>?) {
                    runOnUiThread {
                        applyBtn.isEnabled = true
                        loadingLayout.isVisible = false
                    }
                    if (fileList.isNullOrEmpty()) {
                        runOnUiThread {
                            Toast.makeText(
                                this@TrendySetKeyboardActivity,
                                getString(R.string.download_fail),
                                Toast.LENGTH_SHORT
                            ).show()
                        }
                    } else {
//                        lifecycleScope.launch {
//                            DbFunction.addDownload(data)
//                        }
                        if (file.exists()) {
                            val findFirstDirectory = TrendyDealZipFile.findFirstDirectory(file)
                            Log.d(
                                TrendyApp.Companion.TAG,
                                "----apply------------it=$findFirstDirectory"
                            )
                            runOnUiThread {
                                apply("${findFirstDirectory}/")

                            }
                        }
                    }


                }

            })
        }

    }

    private fun apply(path: String) {
        var skinParentPath = path
        if (path.contains("res")) {
            skinParentPath = path.substringBeforeLast("res")
        }


        TrendySaveCurrentTheme.updateSkinPath(skinParentPath)
        Toast.makeText(
            this@TrendySetKeyboardActivity,
            getString(R.string.theme_application_successful),
            Toast.LENGTH_SHORT
        ).show()
        startActivity(Intent(this, TrendySuccessPreviewActivity::class.java).apply {
            putExtra(TrendySuccessPreviewActivity.key_name, name)
        })
        finish()
    }




}